/* Client side of an ftp service. Actions: 
 - connect to server and request service 
 - send size-of-sile info to server 
 - start receiving file from server 
 - close connection 
 */ 

#include <stdio.h> 
#include <sys/types.h> 
#include <sys/socket.h> 
#include <netinet/in.h> 
#include <arpa/inet.h> 
#include <time.h> 
#include <errno.h>

#define SERVER_PORT_ID 6081 
#define CLIENT_PORT_ID 6086 
#define SERVER_HOST_ADDR "128.119.40.186" 
/* gaia.cs.umass.edu */ 
#define MAXSIZE 512

#define ACK 2 
#define NACK 3 
#define REQUESTFILE 100 
#define COMMANDNOTSUPPORTED 150 
#define COMMANDSUPPORTED 160 
#define BADFILENAME 200 
#define FILENAMEOK 400 
#define STARTTRANSFER 500 
int readn(int sd,char *ptr,int size); 
int writen(int sd,char *ptr,int size);

main() {
  int sockid, newsd, pid, clilen; 
  struct sockaddr_in my_addr, client_addr; 

  printf("server: creating socket\n"); 
  if ((sockid = socket(AF_INET,SOCK_STREAM,0)) < 0) 
  {printf("server: socket error : %d\n", errno); exit(0); }

   printf("server: binding my local socket\n"); 
   bzero((char *) &my_addr,sizeof(my_addr)); 
   my_addr.sin_family = AF_INET; 
   my_addr.sin_port = htons(MY_PORT_ID); 
   my_addr.sin_addr.s_addr = htons(INADDR_ANY); 
   if (bind(sockid ,(struct sockaddr *) &my_addr,sizeof(my_addr)) < 0) 
   {printf("server: bind error :%d\n", errno); exit(0); } 
   printf("server: starting listen \n"); 
   if (listen(sockid,5) < 0) 
   { printf("server: listen error :%d\n",errno);exit(0);} 

   while(1==1) { 
   /* ACCEPT A CONNECTION AND THEN CREATE A CHILD TO DO THE WORK */ 
   /* LOOP BACK AND WAIT FOR ANOTHER CONNECTION */ 
   printf("server: starting accept\n"); 
   if ((newsd = accept(sockid ,(struct sockaddr *) &client_addr, 
   &clilen)) < 0) 
   {printf("server: accept error :%d\n", errno); exit(0); } 
   printf("server: return from accept, socket for this ftp: %d\n", 
   newsd); 
   if ( (pid=fork()) == 0) { 
   /* CHILD PROC STARTS HERE. IT WILL DO ACTUAL FILE TRANSFER */ 
   close(sockid); /* child shouldn't do an accept */ 
   doftp(newsd); 
   close (newsd); 
   exit(0); /* child all done with work */ 
   } 
   /* PARENT CONTINUES BELOW HERE */ 
   close(newsd); /* parent all done with client, only child */ 
   } /* will communicate with that client from now on */ 
} 
